;**************************************************************
;     
; .      ATtiny26L.
;   . 7  2008 .
;**************************************************************
.Include"tn26def.inc"
.DEF  ZNAK1 =R11
.DEF  ZNAK2 =R12
.DEF  ZNAK3 =R13
.DEF  ZNAK4 =R24
LDI   R16,RAMEND    ; 
OUT   SP,R16        ;
RJMP  RESET     
.ORG  006           ;     0
INC   R27
CPI   R27,2
BREQ  Z1
CPI   R27,3
BREQ  Z2
CPI   R27,4
BREQ  Z3
CBI   PORTA,6       ; 4- ()  
OUT   PORTB,ZNAK1   ;      
SBI   PORTB,4       ; 1- ()  
RJMP  SS            ;    
Z1:
CBI   PORTB,4
OUT   PORTB,ZNAK2
SBI   PORTB,5
RJMP  SS
Z2:
CBI   PORTB,5
OUT   PORTB,ZNAK3
SBI   PORTB,6
RJMP  SS
Z3:
CBI   PORTB,6
OUT   PORTB,ZNAK4
SBI   PORTA,6
CLR   R27
SS:   RETI
RESET:
CLR   R0
LDI   R22,15
LDI   R31,127
OUT   DDRB,R31
SBI   DDRA,0
SBI   DDRA,6
OUT   PORTA,R0
OUT   PORTB,R0
LDI   R31,2
OUT   TIMSK,R31
DEC   R31
OUT   TCCR0,R31
LDI   R31,193
OUT   ADMUX,R31
LDI   R31,131
OUT   ADCSRA,R31
START:
SBI   ADCSRA,6      ; 
TEST:
IN    R17,ADCSRA
SBRS  R17,4         ;   ,
RJMP  TEST
READ:
IN    R18,ADCL      ;
IN    R19,ADCH      ; .
CBI   ADCSRA,6      ; 
CPI   R19,3
BREQ  M1
RJMP  CONV
M1:
CPI   R18,232
BRSH  M2
RJMP  CONV
M2:
SBI   PORTA,0
RJMP  START
;**************************************************************
;      
;**************************************************************
CONV:
LDI   R20,232
LDI   R21,3
RCALL DELEN
LDI   R20,100
CLR   R21
RCALL DELEN
MOV   ZNAK4,R15
LDI   R20,10
RCALL DELEN
MOV   ZNAK2,R15
MOV   ZNAK3,R22
MOV   ZNAK1,R18
;**************************************************************
SBIS  PINA,0
RJMP  PAUSE
IND:
MOV   ZNAK3,ZNAK2
MOV   ZNAK2,R22
CPI   ZNAK4,1
BRLO  S1
RJMP  PAUSE
S1:
CBI   PORTA,0
RJMP  START  
PAUSE:
SEI                 ; 
LDI   R28,2
D3:   SER R30
D2:   SER R29
D1:   DEC R29 
BRNE  D1 
DEC   R30 
BRNE  D2
DEC   R28
BRNE  D3
CLI                 ; 
RJMP  START
;**************************************************************
; 
DELEN:
CLR   R15
LOOP:
CP    R18,R20
CPC   R19,R21
BRSH  A1
RJMP  A2
A1:   INC R15
SUB   R18,R20
SBC   R19,R21
BRSH  LOOP
A2:   RET
.EXIT   
